unit ex08_form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Agg2D, ExtCtrls, ComCtrls, StdCtrls ;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    TrackBar1: TTrackBar;
    ComboBox1: TComboBox;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    TrackBar3: TTrackBar;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
  private
    { Private declarations }
    VG : TAgg2D;
    BM : TAggBlendMode;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 ControlStyle:=ControlStyle + [csOpaque ];

 VG:=TAgg2D.Create;
 BM:=AGG_BlendAlpha;

 Image1.Picture.Bitmap.PixelFormat:=pf32bit;
 Image2.Picture.Bitmap.PixelFormat:=pf32bit;

 BitmapAlphaTransparency(Image1.Picture.Bitmap ,255 );
 BitmapAlphaTransparency(Image2.Picture.Bitmap ,255 );

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 VG.Destroy;
 
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 Image1.Picture.Bitmap.Width :=ClientWidth;
 Image1.Picture.Bitmap.Height:=ClientHeight;

 if VG.Attach(Image1.Picture.Bitmap ) then
  begin
   VG.ClearAll(255 ,255 ,255 ,0 );

   VG.MasterAlpha   (TrackBar2.Position / 255 );
   VG.AntiAliasGamma(TrackBar3.Position / 10 );

  // Draw bitmap
   VG.Translate(-55 ,20 );
   VG.TransformImage(
    Image2.Picture.Bitmap ,70 ,50 ,
    Image2.Picture.Bitmap.Width + 50 ,
    Image2.Picture.Bitmap.Height + 50 );

  // Add Star  
   VG.LineWidth(10 );
   VG.LineColor($32 ,$cd ,$32 );
   VG.FillColor($ff ,$d7 ,$00 );

   VG.Star(230 ,290 ,30 ,70 ,55 ,5 );

  // Make some transformations
   VG.Translate(55 ,30 );
   VG.Translate(-ClientWidth / 2 ,-(ClientHeight - 50) / 2 );
   VG.Rotate   (Deg2Rad(TrackBar1.Position ) );
   VG.Translate(ClientWidth / 2 ,(ClientHeight - 50 ) / 2 );
   VG.Translate(90 ,70 );

  // Changing the general composition mode
   VG.BlendMode(BM );

  // Draw the same bitmap
  // Result comes from applying composition mode
   VG.TransformImage(
    Image2.Picture.Bitmap ,70 ,50 ,
    Image2.Picture.Bitmap.Width + 50 ,
    Image2.Picture.Bitmap.Height + 50 ); {}

  end;

end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 FormResize(Sender );
 Repaint;

end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 if ComboBox1.Text = 'AGG_BlendAlpha' then
  BM:=AGG_BlendAlpha;

 if ComboBox1.Text = 'AGG_BlendClear' then
  BM:=AGG_BlendClear;

 if ComboBox1.Text = 'AGG_BlendSrc' then
  BM:=AGG_BlendSrc;

 if ComboBox1.Text = 'AGG_BlendDst' then
  BM:=AGG_BlendDst;

 if ComboBox1.Text = 'AGG_BlendSrcOver' then
  BM:=AGG_BlendSrcOver;

 if ComboBox1.Text = 'AGG_BlendDstOver' then
  BM:=AGG_BlendDstOver;

 if ComboBox1.Text = 'AGG_BlendSrcIn' then
  BM:=AGG_BlendSrcIn;

 if ComboBox1.Text = 'AGG_BlendDstIn' then
  BM:=AGG_BlendDstIn;

 if ComboBox1.Text = 'AGG_BlendSrcOut' then
  BM:=AGG_BlendSrcOut;

 if ComboBox1.Text = 'AGG_BlendDstOut' then
  BM:=AGG_BlendDstOut;

 if ComboBox1.Text = 'AGG_BlendSrcAtop' then
  BM:=AGG_BlendSrcAtop;

 if ComboBox1.Text = 'AGG_BlendDstAtop' then
  BM:=AGG_BlendDstAtop;

 if ComboBox1.Text = 'AGG_BlendXor' then
  BM:=AGG_BlendXor;

 if ComboBox1.Text = 'AGG_BlendAdd' then
  BM:=AGG_BlendAdd;

 if ComboBox1.Text = 'AGG_BlendSub' then
  BM:=AGG_BlendSub;

 if ComboBox1.Text = 'AGG_BlendMultiply' then
  BM:=AGG_BlendMultiply;

 if ComboBox1.Text = 'AGG_BlendScreen' then
  BM:=AGG_BlendScreen;

 if ComboBox1.Text = 'AGG_BlendOverlay' then
  BM:=AGG_BlendOverlay;

 if ComboBox1.Text = 'AGG_BlendDarken' then
  BM:=AGG_BlendDarken;

 if ComboBox1.Text = 'AGG_BlendLighten' then
  BM:=AGG_BlendLighten;

 if ComboBox1.Text = 'AGG_BlendColorDodge' then
  BM:=AGG_BlendColorDodge;

 if ComboBox1.Text = 'AGG_BlendColorBurn' then
  BM:=AGG_BlendColorBurn;

 if ComboBox1.Text = 'AGG_BlendHardLight' then
  BM:=AGG_BlendHardLight;

 if ComboBox1.Text = 'AGG_BlendSoftLight' then
  BM:=AGG_BlendSoftLight;

 if ComboBox1.Text = 'AGG_BlendDifference' then
  BM:=AGG_BlendDifference;

 if ComboBox1.Text = 'AGG_BlendExclusion' then
  BM:=AGG_BlendExclusion;

 if ComboBox1.Text = 'AGG_BlendContrast' then
  BM:=AGG_BlendContrast;

 FormResize(Sender );
 Repaint;

end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
 FormResize(Sender );
 Repaint;

end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
 FormResize(Sender );
 Repaint;

end;

end.
