unit ex50_form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs ,Agg2D,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    VG : TAgg2D;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 ControlStyle:=ControlStyle + [csOpaque ];

 VG:=TAgg2D.Create;

 Image1.Picture.Bitmap.PixelFormat:=pf32bit;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 VG.Destroy;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 Image1.Picture.Bitmap.Width :=ClientWidth;
 Image1.Picture.Bitmap.Height:=ClientHeight;

 if VG.Attach(Image1.Picture.Bitmap ) then
  begin
   VG.ClearAll(255 ,255 ,255 );

  // Some prior positioning
   VG.Scale    (1.25 ,1.25 );
   VG.Translate(-10 ,-135 );

  // This scales View to the size of Form 
   VG.Viewport(
    0 ,0 ,600 ,600 ,
    0 ,0 ,ClientWidth ,ClientHeight ,
    AGG_XMaxYMid );

  // Text Alignment leading lines
   VG.LineColor($A9 ,$A9 ,$A9 );
   VG.Line(250.5 - 150 ,150.5      ,250.5 + 150 ,150.5      );
   VG.Line(250.5       ,150.5 - 20 ,250.5       ,150.5 + 20 );
   VG.Line(250.5 - 150 ,200.5      ,250.5 + 150 ,200.5      );
   VG.Line(250.5       ,200.5 - 20 ,250.5       ,200.5 + 20 );
   VG.Line(250.5 - 150 ,250.5      ,250.5 + 150 ,250.5      );
   VG.Line(250.5       ,250.5 - 20 ,250.5       ,250.5 + 20 );
   VG.Line(250.5 - 150 ,300.5      ,250.5 + 150 ,300.5      );
   VG.Line(250.5       ,300.5 - 20 ,250.5       ,300.5 + 20 );
   VG.Line(250.5 - 150 ,350.5      ,250.5 + 150 ,350.5      );
   VG.Line(250.5       ,350.5 - 20 ,250.5       ,350.5 + 20 );
   VG.Line(250.5 - 150 ,400.5      ,250.5 + 150 ,400.5      );
   VG.Line(250.5       ,400.5 - 20 ,250.5       ,400.5 + 20 );
   VG.Line(250.5 - 150 ,450.5      ,250.5 + 150 ,450.5      );
   VG.Line(250.5       ,450.5 - 20 ,250.5       ,450.5 + 20 );
   VG.Line(250.5 - 150 ,500.5      ,250.5 + 150 ,500.5      );
   VG.Line(250.5       ,500.5 - 20 ,250.5       ,500.5 + 20 );
   VG.Line(250.5 - 150 ,550.5      ,250.5 + 150 ,550.5      );
   VG.Line(250.5       ,550.5 - 20 ,250.5       ,550.5 + 20 );

  // Font & Colors
   VG.FillColor($00 ,$00 ,$8B );
   VG.NoLine;
   VG.TextHints(CheckBox1.Checked );
   VG.Font('Times New Roman' ,40.0 ,false ,false ,AGG_VectorFontCache );
   
  // All Text Alignment Cases
   VG.TextAlignment(AGG_AlignLeft ,AGG_AlignBottom );
   VG.Text(250.0 ,150.0 ,'Left-Bottom' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignCenter ,AGG_AlignBottom );
   VG.Text(250.0 ,200.0 ,'Center-Bottom' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignRight ,AGG_AlignBottom );
   VG.Text(250.0 ,250.0 ,'Right-Bottom' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignLeft ,AGG_AlignCenter );
   VG.Text(250.0 ,300.0 ,'Left-Center' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignCenter ,AGG_AlignCenter );
   VG.Text(250.0 ,350.0 ,'Center-Center' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignRight ,AGG_AlignCenter );
   VG.Text(250.0 ,400.0 ,'Right-Center' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignLeft ,AGG_AlignTop );
   VG.Text(250.0 ,450.0 ,'Left-Top' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignCenter ,AGG_AlignTop );
   VG.Text(250.0 ,500.0 ,'Center-Top' ,true ,0 ,0 );

   VG.TextAlignment(AGG_AlignRight ,AGG_AlignTop );
   VG.Text(250.0 ,550.0 ,'Right-Top' ,true ,0 ,0 );

  end;

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 FormResize(Sender );
 Repaint;

end;

end.
